<?php
Class Thesaurus{

private $wordcount=0;
private $resultcount=0;
private $worddata=array();
private $state='';
private $socket;
private $xml_parser;

function __construct() {
	
	
if (!defined("CACHE"))
     define("CACHE", FALSE);

if (!defined("GLOBAL_CACHE"))
     define("GLOBAL_CACHE", false);

if (!defined("TTL"))
     define("TTL", 0);

if (!defined("PAGE_CACHE"))
     define("PAGE_CACHE", false);

$this->socket = pfsockopen("10.0.0.2", 49152);
stream_set_blocking ($this->socket , 1);
$this->xml_parser = xml_parser_create();
xml_set_object ($this->xml_parser, $this );
}

function startElementHandler ($parser, $name, $attrib){
switch ($name) {
case $name=="RESULT": {
$worddata[$this->wordcount][$this->resultcount]["exact"] = $attrib["EXACT"];
$worddata[$this->wordcount][$this->resultcount]["stemmed"] = $attrib["STEMMED"];
$worddata[$this->wordcount][$this->resultcount]["translated"] = $attrib["TRANSLATED"];
$worddata[$this->wordcount][$this->resultcount]["editDistance"] = $attrib["EDITDISTANCE"];
break;
}

default : {$this->state=$name;break;}
}
}

function endElementHandler ($parser, $name){

$state='';
if($name=="WORD"){$this->wordcount++;$this->resultcount=0;}
if($name=="RESULT"){$this->resultcount++;}
}

function characterDataHandler ($parser, $data) {
if (!$this->state) {return;}
if ($this->state=="ORIGINAL") { $this->worddata[$this->wordcount]["original"] = $this->worddata[$this->wordcount]["original"] . $data;}
if ($this->state=="SYNONYM") { $this->worddata[$this->wordcount][$this->resultcount]["synonym"] = $this->worddata[$this->wordcount][$this->resultcount]["synonym"] . $data;}
if ($this->state=="TERM") { $this->worddata[$this->wordcount][$this->resultcount]["term"] = $this->worddata[$this->wordcount][$this->resultcount]["term"] . $data;}
if ($this->state=="EXPLANATION"){$this->worddata[$this->wordcount][$this->resultcount]["explanation"] = $this->worddata[$this->wordcount][$this->resultcount]["explanation"] . $data;}
if ($this->state=="THESAURUS") { $this->worddata[$this->wordcount][$this->resultcount]["thesaurus"] = $data;}
}

function translate ($text){
	
$words= preg_split("/[\s]+/", $text);

$xml = '<document><sources><thesaurus>1</thesaurus><thesaurus>2</thesaurus><thesaurus>3</thesaurus></sources><text>';
$xmlEnd = ' </text></document>';


foreach($words as $word){
	if(strlen($word)>0)
	$xml = $xml . ' <word>' . $word . '</word>';
}

$xml = $xml . $xmlEnd;
$res = fwrite($this->socket, $xml);
    while (!feof($this->socket)) {
        $desc = $desc . fgets($this->socket, 100);
    }

fclose($this->socket);
xml_set_element_handler($this->xml_parser, "startElementHandler", "endElementHandler");
xml_set_character_data_handler($this->xml_parser, "characterDataHandler");
xml_parser_set_option($this->xml_parser,XML_OPTION_TARGET_ENCODING,"UTF-8");
if(!(xml_parse($this->xml_parser, $desc))){
    die("Error on line " . xml_get_current_line_number($this->xml_parser));
}

xml_parser_free($this->xml_parser);


return $this->worddata;
}


}

?>