#ifndef _NEWLINE_PARSER_H
#define _NEWLINE_PARSER_H

#include "libs/buffer.h"

struct newline_parser {
	enum {
		NEWLINE_PARSER_INIT,
		NEWLINE_PARSER_TEXT,
		NEWLINE_PARSER_NEWLINE_FIRST,
		NEWLINE_PARSER_NEWLINE_MANY,
	} state;

	struct buffer buffer;

	void *data;

	/* events callbacks */
	void (*on_text)(struct newline_parser *parser,
		const char *s, unsigned int l);
	void (*on_newline)(struct newline_parser *parser);
};

void
newline_parser_init(struct newline_parser *parser);

void
newline_parser_deinit(struct newline_parser *parser);

void
newline_parser_parse(struct newline_parser *parser,
	const char *s, unsigned int l, int output);

void
newline_parser_flush(struct newline_parser *parser);

void
newline_parser_finish(struct newline_parser *parser);

#endif
