#ifndef _RESPONSE_H
#define _RESPONSE_H

#include "libs/buffer.h"

#include "newline-parser.h"

struct response_result {
	struct response_result *_prev;
	struct response_result *_next;

	int exact;
	int stemmed;
	int translated;
	unsigned int edit_distance;

	char *synonym;
	unsigned int synonym_length;

	char *term;
	unsigned int term_length;

	char *explanation;
	unsigned int explanation_length;

	char *thesaurus;
	unsigned int thesaurus_length;
};

struct response_word {
	char *original;
	unsigned int original_length;

	struct response_result results;
};

struct response {
	//struct buffer text;
	struct newline_parser text;
	struct response_word *word;
	struct buffer original;
	struct response_result *result;
	struct buffer synonym;
	struct buffer term;
	struct buffer explanation;
	struct buffer thesaurus;

	struct buffer output;
	int explanation_id;
};

extern const struct response_parser_handler response_handler;

void
response_init(struct response *response);

void
response_deinit(struct response *response);

void
response_word_init(struct response_word *word);

void
response_word_deinit(struct response_word *word);

void
response_result_init(struct response_result *result);

void
response_result_deinit(struct response_result *result);

#endif
