#ifndef _TEXT_PARSER_H
#define _TEXT_PARSER_H

#include "libs/buffer.h"

struct text_parser {
	enum {
		TEXT_PARSER_INIT,
		TEXT_PARSER_WORD,
		TEXT_PARSER_WORD_DOT,
		TEXT_PARSER_SEPARATOR,
	} state;

	struct buffer buffer;

	void *data;

	/* events callbacks */
	void (*on_word)(struct text_parser *parser,
		const char *s, unsigned int l);
	void (*on_separator)(struct text_parser *parser,
		const char *s, unsigned int l);
};

void
text_parser_init(struct text_parser *parser);

void
text_parser_deinit(struct text_parser *parser);

void
text_parser_parse(struct text_parser *parser,
	const char *s, unsigned int l);

void
text_parser_finish(struct text_parser *parser);

#endif
