#ifndef _BUFFER_H
#define _BUFFER_H

#include <stdio.h>

struct buffer {
	unsigned int i;
	unsigned int size;
	char *data;
};

void buffer_init(struct buffer *buffer);
void buffer_deinit(struct buffer *buffer, unsigned int free_data);

void buffer_write(struct buffer *buffer, const char *data, size_t size);
void buffer_write_char(struct buffer *buffer, char ch);
void buffer_write_string(struct buffer *buffer, const char *string);
void buffer_write_format(struct buffer *buffer, const char *format, ...);
void buffer_move(struct buffer *buffer, char **out, unsigned int *out_length);
void buffer_duplicate(struct buffer *buffer, char **out, unsigned int *out_length);

#endif
