#ifndef _IO_LOOP_H
#define _IO_LOOP_H

#ifndef WIN32
#include <sys/select.h>
#endif

#include <sys/types.h>

#ifdef WIN32
#include <ws2tcpip.h>
#endif

#include "libs/io-socket.h"

struct io_loop {
	fd_set rfds, wfds;
	struct io_socket sockets;
};

void io_loop_init(struct io_loop *io_loop);
void io_loop_deinit(struct io_loop *io_loop);

void io_loop_select(struct io_loop *io_loop);

void io_loop_add(struct io_loop *io_loop, struct io_socket *socket);
void io_loop_remove(struct io_loop *io_loop, struct io_socket *socket);

#endif
