#include <assert.h>

#include "libs/buffer.h"
#include "libs/uri.h"

void
uri_encode_to_buffer(const char *s, unsigned int l,
	struct buffer *buffer)
{
	unsigned int i;

	assert(s);
	assert(l);
	assert(buffer);

	for(i = 0; i < l; i++) {
		if(s[i] >= '0' && s[i] <= '9') {
			buffer_write_char(buffer, s[i]);
			continue;
		}

		if(s[i] >= 'A' && s[i] <= 'Z') {
			buffer_write_char(buffer, s[i]);
			continue;
		}

		if(s[i] >= 'a' && s[i] <= 'z') {
			buffer_write_char(buffer, s[i]);
			continue;
		}

		buffer_write_format(buffer, "%%%02hx", s[i]);
	}
}

void
uri_encode(const char *s, unsigned int l,
	char **encoded, unsigned int *encoded_length)
{
	struct buffer buffer;

	assert(s);
	assert(l);
	assert(encoded);
	assert(encoded_length);

	buffer_init(&buffer);
	uri_encode_to_buffer(s, l, &buffer);
	buffer_move(&buffer, encoded, encoded_length);
	buffer_deinit(&buffer, 0);
}
