#include <stdio.h>
#include <stdlib.h>

/* xmalloc() never returns NULL. Not even for zero-size allocations. */
void *
xmalloc(size_t size)
{
	void *p;

	p = malloc(size);
	if(!p) {
		fprintf(stderr, "error: Out of memory\n");
		abort();
	}

	return p;
}

/* xcalloc() never returns NULL. Not even for zero-size allocations. */
void *
xcalloc(size_t nmemb, size_t size)
{
	void *p;

	p = calloc(nmemb, size);
	if(!p) {
		fprintf(stderr, "error: Out of memory\n");
		abort();
	}

	return p;
}

/* xrealloc() never returns NULL on failure, but may return NULL if size is
 * zero, in which case the reallocation is equivalent to a call to free().
 */
void *
xrealloc(void *ptr, size_t size)
{
	void *p;

	if(size == 0)
		return realloc(ptr, size);

	p = realloc(ptr, size);
	if(!p) {
		fprintf(stderr, "error: Out of memory\n");
		abort();
	}

	return p;
}
