#ifndef _CONNECTION_H
#define _CONNECTION_H

#include <libxml/parser.h>

#include "libs/io-socket.h"

#include "request.h"
#include "request-parser.h"

struct connection {
	struct io_socket *socket;

	xmlParserCtxtPtr xml_parser;
	struct request_parser request_parser;

	struct request request;

	unsigned int lookups;
	unsigned int results;
};

void connection_init(struct connection *c);
void connection_deinit(struct connection *c);
void connection_handle(struct connection *c,
	const unsigned char *data, unsigned long int n);

#endif
