#ifndef _DATABASE
#define _DATABASE

#include <mysql/mysql.h>

struct synonym;
struct term;

struct database {
	MYSQL *mysql;
};

void database_init(struct database *db);
void database_deinit(struct database *db);

void database_connect(struct database *db, const char *options_group);
void database_disconnect(struct database *db);

void database_load(struct database *db,
	void (*category_callback)(char *s[], unsigned long l[]),
	void (*thesaurus_callback)(char *s[], unsigned long l[]),
	void (*term_callback)(char *s[], unsigned long l[]),
	void (*synonym_callback)(char *s[], unsigned long l[]));

#endif
