#ifndef _SYNONYM_H
#define _SYNONYM_H

#include "transformations.h"

struct term;
struct thesaurus;

struct synonym {
	unsigned long int id;
	struct thesaurus *thesaurus;
	struct term *term;
	/* The search word, stored as a UTF-8-encoded string. */
	char *word;
	unsigned int word_length;

	/* This field refers to whether this word that was added during
	 * start-up was translated and/or stemmed. This way, we can translate
	 * or stem a word and only look for those during retrieval. */
	struct transformations transformations;
} __attribute__((__packed__));

void synonym_init(struct synonym *synonym);
void synonym_deinit(struct synonym *synonym);

#endif
