#include <assert.h>

#include "transformations.h"

void
transformations_init(struct transformations *t,
	int translated,
	int stemmed)
{
	assert(t);

	t->translated = translated;
	t->stemmed = stemmed;
}

void
transformations_or(struct transformations *result,
	const struct transformations *a, const struct transformations *b)
{
	assert(result);
	assert(a);
	assert(b);

	result->translated = a->translated || b->translated;
	result->stemmed = a->stemmed || b->stemmed;
}

void
transformations_and(struct transformations *result,
	const struct transformations *a, const struct transformations *b)
{
	assert(result);
	assert(a);
	assert(b);

	result->translated = a->translated && b->translated;
	result->stemmed = a->stemmed && b->stemmed;
}
