#include <stdlib.h>

#include "translate.h"
#include "translate-la-no.h"

/* Sort alphabetically by the "from" word, but treat end-of-word as lower
 * priority than letters. This way, the longer sequencies will be tried
 * before the shorter ones. For instance, "CH" should be translated before
 * "C"; otherwise, the "CH" rule will never be matched. */
static struct translation table[] = {
	{"CH",  "K",  0, 0},
	{"C",   "K",  0, 0},
	{"EU",  "EV", 0, 0},
	{"PH",  "F",  0, 0},
	{"TH",  "T",  0, 0},
	{"RRH", "R",  0, 0},
	{"X",   "KS", 0, 0},
	{NULL,  NULL, 0, 0},
};

void translate_la_no(const char *s, unsigned int l,
	char **out, unsigned int *out_length)
{
	static int initialized = 0;

	if(!initialized) {
		translate_prepare(table);
		initialized = 1;
	}

	translate(table, s, l, out, out_length, 1);
}
