#ifndef _TRIE_H
#define _TRIE_H

struct synonym_array;

struct trie {
	struct trie *children;
	unsigned char nchildren;

	char ch;
	struct synonym_array *synonyms;
} __attribute__((__packed__));

void trie_init(struct trie *trie, char ch);
void trie_deinit(struct trie *trie);

/* Note: MUST be called prior to any trie_search() call. */
void trie_sort(struct trie *trie);

struct trie *trie_insert(struct trie *trie, const char *s, unsigned int l);
struct trie *trie_search(struct trie *trie, const char *s, unsigned int l);

#endif
